// Filt.cpp :   CFilt
// (C) Red User, 2004
// mailto:reduser@nm.ru

#include "stdafx.h"
#include "Filt.h"

CFilt::CFilt()
    : m_iMaxEmpty(-1) 
{
    m_sd[F].lpStr = NULL;
    m_sd[L].lpStr = NULL;
    m_sd[B].lpStr = NULL;
    m_sd[E].lpStr = NULL;
    m_sd[F].iStrLen = 0;
    m_sd[L].iStrLen = 0;
    m_sd[B].iStrLen = 0;
    m_sd[E].iStrLen = 0;
}

CFilt::~CFilt()
{
    delete [] m_sd[F].lpStr;
    delete [] m_sd[L].lpStr;
    delete [] m_sd[B].lpStr;
    delete [] m_sd[E].lpStr;
}

BOOL CFilt::DelFromTo(const char *lpF, const char *lpL)
{
#ifdef FILT_DELFROMTO_MEMORY_ERROR
    return FALSE;
#else
    m_sd[F].iStrLen = (int)strlen(lpF),
    m_sd[L].iStrLen = (int)strlen(lpL);
    if (m_sd[F].lpStr = new char[m_sd[F].iStrLen + 1])
        strcpy(m_sd[F].lpStr, lpF);
    else
        return FALSE;
    if (m_sd[L].lpStr = new char[m_sd[L].iStrLen + 1])
        strcpy(m_sd[L].lpStr, lpL);
    else
        return FALSE;
    //      
    for (int iCur = 0; iCur < SHIFT_SIZE; iCur++)
    {
        m_sd[F].rgiShift[iCur] = m_sd[F].iStrLen;
        m_sd[L].rgiShift[iCur] = m_sd[L].iStrLen;
    }
    for (int iCur = 0; iCur < m_sd[F].iStrLen - 1; iCur++)
        m_sd[F].rgiShift[(unsigned char)m_sd[F].lpStr[iCur]] = m_sd[F].iStrLen - iCur - 1;
    for (int iCur = 0; iCur < m_sd[L].iStrLen - 1; iCur++)
        m_sd[L].rgiShift[(unsigned char)m_sd[L].lpStr[iCur]] = m_sd[L].iStrLen - iCur - 1;
    return TRUE;
#endif
}

BOOL CFilt::DelFromToEnd(const char *lpB)
{
#ifdef FILT_DELFROMTOEND_MEMORY_ERROR
    return FALSE;
#else
    m_sd[B].iStrLen = (int)strlen(lpB);
    if (m_sd[B].lpStr = new char[m_sd[B].iStrLen + 1])
        strcpy(m_sd[B].lpStr, lpB);
    else
        return FALSE;
    m_sd[E].iStrLen = 2;
    if (m_sd[E].lpStr = new char[3])
        strcpy(m_sd[E].lpStr, "\r\n");
    else
        return FALSE;
    //      
    for (int iCur = 0; iCur < SHIFT_SIZE; iCur++)
    {
        m_sd[B].rgiShift[iCur] = m_sd[B].iStrLen;
        m_sd[E].rgiShift[iCur] = m_sd[E].iStrLen;
    }
    for (int iCur = 0; iCur < m_sd[B].iStrLen - 1; iCur++)
        m_sd[B].rgiShift[(unsigned char)m_sd[B].lpStr[iCur]] = m_sd[B].iStrLen - iCur - 1;
    for (int iCur = 0; iCur < m_sd[E].iStrLen - 1; iCur++)
        m_sd[E].rgiShift[(unsigned char)m_sd[E].lpStr[iCur]] = m_sd[E].iStrLen - iCur - 1;
    return TRUE;
#endif
}

void CFilt::SetMaxEmpty(int iMax)
{
    m_iMaxEmpty = iMax;
}

//  .
//  pBuf -     (  ), 
//  iSize -     .
//   iSize .     ,
//   iSize .      
//  .
void CFilt::Run(char *pBuf, int &iSize) const
{
    int iFMark,
        iBMark,
        iTMark,
        iMark = 0;

#ifdef _DEBUG
    FILETIME ftCreat,
             ftExit,
             ftKernel1,
             ftKernel2,
             ftUser1,
             ftUser2;
    ULARGE_INTEGER uiKernel1,
                   uiKernel2,
                   uiUser1,
                   uiUser2;
    GetThreadTimes(GetCurrentThread(), &ftCreat, &ftExit, &ftKernel1, &ftUser1);
#endif

    for (;;)
    {
        if (m_sd[B].iStrLen)
            iBMark = Find(pBuf, B, iMark, iSize - 1);
        else
            iBMark = -1;
        if (m_sd[F].iStrLen)
            iFMark = Find(pBuf, F, iMark, iSize - 1);
        else
            iFMark = -1;
        if (iFMark < 0 && iBMark < 0)
            //    m_sd[F].lpStr,  m_sd[B].lpStr
            break;
        if ((iFMark > -1) && (iBMark < 0 || iFMark <= iBMark))
        {
            if (m_sd[L].iStrLen)
                iTMark = Find(pBuf, L, iFMark + m_sd[F].iStrLen, iSize - 1);
            else                                                           
                iTMark = -1;                                               
            if (iTMark > -1)                                               
                Delete(pBuf, iFMark, iTMark + m_sd[L].iStrLen - 1, iSize);  
            else                                                           
            {   
                Delete(pBuf, iFMark, iSize - 1, iSize);  
                break;                                                                       
            }   
            iMark = iFMark;
        }           
        else
        {                       
            iTMark = Find(pBuf, E, iBMark + m_sd[B].iStrLen, iSize - 1);                      
            if (iTMark > -1)                                                                 
                Delete(pBuf, iBMark, iTMark - 1, iSize);                                      
            else                                                                             
            { 
                Delete(pBuf, iBMark, iSize - 1, iSize);       
                break;                                                                       
            } 
            iMark = iBMark;
        }
    }
    if (m_iMaxEmpty > -1)
        DelEmpty(pBuf, iSize);

#ifdef _DEBUG
    GetThreadTimes(GetCurrentThread(), &ftCreat, &ftExit, &ftKernel2, &ftUser2);
    uiKernel1.LowPart = ftKernel1.dwLowDateTime;
    uiKernel1.HighPart = ftKernel1.dwHighDateTime;
    uiKernel2.LowPart = ftKernel2.dwLowDateTime;
    uiKernel2.HighPart = ftKernel2.dwHighDateTime;
    uiUser1.LowPart = ftUser1.dwLowDateTime;
    uiUser1.HighPart = ftUser1.dwHighDateTime;
    uiUser2.LowPart = ftUser2.dwLowDateTime;
    uiUser2.HighPart = ftUser2.dwHighDateTime;
    TRACE(" : %u\n", 
        uiKernel2.QuadPart - uiKernel1.QuadPart +
        uiUser2.QuadPart - uiUser1.QuadPart);
#endif
}

//      (    ),   
//    ,  m_iMaxEmpty. 
//  pBuf -     (  ), 
//  iSize -     .
//   iSize .
void CFilt::DelEmpty(char *pBuf, int &iSize) const
{
    int iPos = 0,
    //     
        iEmpty = 0,
    //  
        iBeg = 0;
    // bEnd == TRUE,    '\r'
    BOOL bEnd = FALSE,
    // bSpc == TRUE,    N >= 0 , M >= 0  
    //       '\r',     
    //  (,  )
         bSpc = TRUE;
    
    while (iPos <= (iSize - 1))  
    {
        switch (pBuf[iPos])
        {
        case '\x9':    
        case ' ':   bEnd = FALSE;
                    break;                    
        case '\r':  if (bEnd)
                        bSpc = FALSE;
                    else
                        bEnd = TRUE;
                    break;
        case '\n':  if (bEnd)
                    {
                        if (bSpc)
                            iEmpty++;
                        else
                            iEmpty = 0;
                        if (iEmpty > m_iMaxEmpty)
                        {
                            Delete(pBuf, iBeg, iPos, iSize);
                            iPos = iBeg - 1;
                        }
                        else
                            iBeg = iPos + 1;
                        bEnd = FALSE;
                        bSpc = TRUE;
                        break;
                    }   
                    //   '\n'   '\r', 
                    //     
        default:    bSpc = FALSE;
                    bEnd = FALSE;
        }
        iPos++;
    }

}

//    pBuf    m_sd[iStrNum].lpStr, 
//     iFrom    iTo.   
//  ,        pBuf.
//       iFrom > iTo,   -1.
int CFilt::Find(const char *pBuf, int iStrNum, int iFrom, int iTo) const
{
    ASSERT(iFrom >= 0);

    if (m_sd[iStrNum].iStrLen > 1)
    {
        //     (. , . )
        iFrom += m_sd[iStrNum].iStrLen - 1;
        while (iFrom <= iTo)
        {
            for (int iStrCur = m_sd[iStrNum].iStrLen - 1, iBufCur = iFrom; iStrCur >= 0; iStrCur--, iBufCur--)
                if (pBuf[iBufCur] != m_sd[iStrNum].lpStr[iStrCur])
                    break;
            if (iStrCur < 0)
                return iBufCur + 1;
            iFrom += m_sd[iStrNum].rgiShift[(unsigned char)pBuf[iFrom]];
        }
    }
    else
    {
        while (iFrom <= iTo)
        {
            if (pBuf[iFrom] == *(m_sd[iStrNum].lpStr))
                return iFrom;
            iFrom++;
        }
    }

    return -1;
}

//    pBuf ,    iFrom    iTo.
//  iSize -  .    iSize.
void CFilt::Delete(char *pBuf, int iFrom, int iTo, int &iSize) const
{
    ASSERT(iFrom >= 0);
    ASSERT(iFrom <= iTo);

    memmove(pBuf + iFrom, pBuf + iTo + 1, iSize - (iTo + 1));
    iSize -= iTo - iFrom + 1;
}
